#if !defined (__HH)
#define __HH

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <math.h>

#if !defined (__SONZEICHH)
#include "sonzeich.h"
#endif

#if !defined (ED)
#define ED        clrscr()
#endif

#if !defined (WAIT)
#define WAIT      keyb()
#endif

#if !defined (MARKCOLOR)
#define MARKCOLOR    0x60
#define NORMCOLOR    0x07
#endif

#if !defined ALL_RIGHT
#define ALL_RIGHT       0
#endif

#if !defined TRUE    
#define TRUE            1
#endif

#if !defined TROUBLE
#define TROUBLE         1
#endif

#if !defined FALSE
#define FALSE           0
#endif

int keyb(void)
	{
	int k;
	if((k=getch())==0) k = getch()<<8;
	return(k);
	}

void cup(int y, int x)
	{
	union REGS regs;
	regs.h.ah=2;
	regs.h.bh=0;
	regs.h.dh=y;
	regs.h.dl=x;
	int86(0x10,&regs,&regs);
	}

void pcyx(int y,int x,char ch)
	{
	union REGS pregs;
	pregs.h.ah=0x2;
	pregs.h.bh=0;
	pregs.h.dh=y;
	pregs.h.dl=x;
	int86(0x10,&pregs,&pregs);
	pregs.h.ah=0xa;
	pregs.h.al=ch;
	pregs.x.cx=1;
	int86(0x10,&pregs,&pregs);
	}

void pyx(char ch)
	{
	union REGS pregs;
	pregs.h.ah=0xe;
	pregs.h.al=ch;
	pregs.x.cx=1;
	pregs.h.bh=0;
	int86(0x10,&pregs,&pregs);
	}

void psyx(char *field)
	{
	while(*field) pyx(*field++);
	}

void ps(int y,int x, char *field)
	{
	union REGS pregs;
	pregs.h.ah=0x2;
	pregs.h.bh=0;
	pregs.h.dh=y;
	pregs.h.dl=x;
	int86(0x10,&pregs,&pregs);
	psyx(field);
	}

void cpcyx(int y,int x,char ch,int farbe)
	{
	int off=y*160+x*2;
	int seg=(peekb(0x40,0x49)==7)?0xb000:0xb800;
	pokeb(seg,off,ch);
	pokeb(seg,off+1,farbe);
	}

void cps(int y,int x,char *field,int farbe)
	{
	while(*field) cpcyx(y,x++,*field++,farbe);
	gotoxy(x+1,y+1);
	}

void put_intf(int zahl, int stellen)
	{
	int i;
	if(!stellen) return;
	if(!zahl)
		{
		for(i=stellen;i>1;i--) pyx(SPACE);
		pyx('0');
		return;
		}
	if(zahl<0) zahl=-zahl;
	for(i=stellen; i>0; i--)
		{
		pyx((int)(zahl/pow10(i-1)) ? ((int)(zahl/pow(10,i-1))%10) + 48 : 32);
		}
	}

#endif
